﻿Namespace App10

    Class Student : Implements IComparable

        Private _FirstName As String
        Private _LastName As String

        Public Sub New(ByVal firstName As String,
            ByVal lastName As String)
            Me.LastName = lastName
            Me.FirstName = firstName
        End Sub

        Public Property FirstName() As String
            Get
                Return _FirstName
            End Get
            Set(value As String)
                _FirstName = value
            End Set
        End Property

        Public Property LastName() As String
            Get
                Return _LastName
            End Get
            Set(value As String)
                _LastName = value
            End Set
        End Property

        Public Function CompareTo(ByVal obj As Object) As Integer _
                Implements IComparable.CompareTo
            Dim anotherStudent As Student = DirectCast(obj, Student)
            If (Me.LastName = anotherStudent.LastName) Then
                Return Me.FirstName.CompareTo(anotherStudent.FirstName)
            Else
                Return Me.LastName.CompareTo(anotherStudent.LastName)
            End If
        End Function
    End Class

    Class Program

        Shared Sub Main(ByVal args As String())

            Dim students() As Student = {
                New Student("John", "Suzuki"),
                New Student("Liam", "Doe"),
                New Student("John", "Smith"),
                New Student("Joe", "Doe"),
                New Student("John", "Tirano"),
                New Student("Louis", "Smith")}

            Console.WriteLine(vbCrLf & "Unsorted:")
            Console.WriteLine("====================")
            For Each student As Student In students

                Console.WriteLine(student.LastName &
                    ", " + student.FirstName)
            Next

            Array.Sort(students)

            Console.WriteLine(vbCrLf & "Sorted:")
            Console.WriteLine("====================")
            For Each student As Student In students

                Console.WriteLine(student.LastName &
                    ", " & student.FirstName)
            Next

            Console.ReadKey()
        End Sub
    End Class
End Namespace
